function [invM]=pseudoinv(M,tol)

if nargin==1
  tol=eps*max(size(M)) * norm(M);
end

[u,s,v]=svd(M);

invs=s';
ii=find(abs(diag(s)/s(1,1))>tol);
for i=ii'
  invs(i,i)=1/s(i,i);
end 

jj=find(abs(diag(s)/s(1,1))<=tol);
for i=jj'
  invs(i,i)=0;
end


invM=v*invs*u';
