function [T]=bruitTR(sigma_angle,sigma_t,moy_angle,moy_t)
% Utilisation 1:
%  [T]=bruitTR(sigma_angle, sigma_t)
% avec size(sigma_angle)=[1,1] et size(sigma_t)=[3,1]
%
% Utilisation 2:
%  [T]=bruitTR(sigma_angle,sigma_t,moy_angle,moy_t)
% avec size(sigma_angle)=[1,1] et size(sigma_t)=[3,1]
%      size(moy_angle)=[1,1]   et size(moy_t)=[3,1]

switch nargin
case 2
  moy_angle=0;
  moy_t=zeros(3,1);
case 4
otherwise
  disp('Mauvais appel de bruitTR')
  return
end

if size(sigma_t)==[1,1]
  sigma_t=sigma_t*ones(3,1);
end

axe=rand(3,1);
angle=randn*sigma_angle+moy_angle;
T=Rot(axe,angle);
t=randn(3,1).*sigma_t+moy_t;

T(1:3,4)=t;
