function [ Ksi, sigma, Camera, Mire ] = creerRobot()
% [ Ksi, sigma, Camera, Mire ] = creerRobot()

nbArt=0;
while (nbArt==0)
   nbArt=input('Combien d''articulations ?  ');
end

Ksi=zeros(6*nbArt,1);
sigma=zeros(nbArt,1);


disp('Transformation monde->base')
satisfait=0;
while ~satisfait  
  aleatoire=input('Souhaitez-vous un tirage aleatoire ? (0/1)');
  if aleatoire
    axe=(rand(3,1)-0.5);
		angle=rand*2*pi;
		Camera=Rot(axe,angle);
    Camera(1:3,4)=[100*(rand(2,1)-0.5);100+20*rand]
  else
    Camera=lireTransRigide;
  end
  Camera  
  satisfait=input('Etez-vous satisfait (0/1) ');
end

defaut=0;
if defaut
  theta_z=atan2(T(3,1),T(3,2));
  toto=norm(T(3,1:2));
  alpha_z=atan2(sign(sin(theta_z))*sign(T(3,1))*sqrt(toto),T(3,3));
  gamma_z=atan2(T(1,3),-T(2,3));
  M=[ 0, sin(gamma_z)*sin(alpha_z), cos(gamma_z); ...
      0, -cos(gamma_z)*sin(alpha_z), sin(gamma_z); ...
      1, cos(alpha_z),0];
  if (rank(M)==3)
    aux=M\T(1:3,4);
  else
    aux=zeros(3,1);
  end
  
  b_z=aux(1);
  r_z=aux(2);
  d_z=aux(3);
  
  Ksi(1)=gamma_z;
  Ksi(2)=b_z;
end

if (nbArt>1)
   disp('Transformation base->corps1');
else
   disp('Transformation base->effecteur');
end

reponse=lireArt;
sigma(1)=reponse(6);
if defaut
  Ksi(3:5)=[0;alpha_z; d_z];
  Ksi(6:7)=[reponse(3)+theta_z; reponse(4)+r_z];
else
  Ksi(1:3)=[0;0;0];
  Ksi(4:6)=reponse(3:5)';
end

for (i=2:(nbArt-1))
   disp(['Transformation corps',...
      num2str(i-1),...
   	'->corps',...
      num2str(i)]);
   reponse=lireArt;
   sigma(i)=reponse(6);
   if defaut
     Ksi(5*i-2)=0;
     Ksi(5*i-1:5*i+2)=reponse(1:4)';
   else
     Ksi(6*i-5)=0;
     Ksi(6*i-4:6*i)=reponse(1:5)';
   end   
end

if (nbArt>1)
   disp(['Transformation corps',...
      num2str(nbArt-1),...
      '->effecteur']);
	reponse=lireArt;
	sigma(nbArt)=reponse(6);
  if defaut
    Ksi(5*nbArt-2)=0;
    Ksi(5*nbArt-1:5*nbArt+2)=reponse(1:4)';
  else
    Ksi(6*nbArt-5)=0;
    Ksi(6*nbArt-4:6*nbArt)=reponse(1:5)';
  end
end

disp('Transformation effecteur->outil');
if defaut
  Ksi(5*nbArt+3)=input('alpha (deg)=')*pi/180;
  Ksi(5*nbArt+4)=input('d (mm)=');
  Ksi(5*nbArt+5)=input('theta (deg)=')*pi/180;
  Ksi(5*nbArt+6)=input('r (mm)=');
else
  satisfait=0;
  while ~satisfait  
    aleatoire=input('Souhaitez-vous un tirage aleatoire ? (0/1)');
    if aleatoire
      axe=(rand(3,1)-0.5);
		  angle=rand*2*pi;
		  Mire=Rot(axe,angle);
      Mire(1:3,4)=[100*(rand(2,1)-0.5);100+20*rand]
    else
      Mire=lireTransRigide;
    end
    Mire
    satisfait=input('Etez-vous satisfait (0/1) ');
  end
end

