function [X]=robot(q)
% Amene le robot en la position articulaire q
% et renvoie l'information X delivree par le capteur
global q_cour;

load config

if (nargin==0)
  q=zeros(size(sigma_ref));
end

% config contient 
%    sigma_ref, Ksi_ref, Camera_ref, Mire_ref
%    rep_q, sigma_ang, sigma_t

%Camera_ref


qb=q*(1+(randn*rep_q));

q_cour=q;

[T, Reperes]=MGDref(qb,Ksi_ref,sigma_ref);
X=perception(T,Camera_ref,Mire_ref);
visu(Reperes,Camera_ref,Mire_ref)
X=bruitTR(sigma_ang,sigma_t)*X;

